package nl.amis.proxy;
import java.io.IOException;

import java.util.Enumeration;
import java.util.Hashtable;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class HttpProxyServlet extends HttpServlet
{

    final static String REMOTE_HOST = "remotehost";
    final static String REMOTE_PORT = "remoteport";

    public HttpProxyServlet() {
    }
   
    public void doGet(HttpServletRequest httpservletrequest, HttpServletResponse httpservletresponse)
        throws ServletException, IOException
    {
        String s = httpservletrequest.getQueryString();
        if ((s==null) ||(s.length() <3)) httpservletresponse.sendError(503);
        // we need to extract the target url from the parameters remotehost and remoteport
        String url = "";
        String urlTail = "";
        String remotehost = findString(s,REMOTE_HOST);
        s=s.replaceFirst(REMOTE_HOST+"="+remotehost,"");
        String remoteport = findString(s,REMOTE_PORT);
        s=s.replaceFirst(REMOTE_PORT+"="+remoteport,"");
        if((s != null) && (s.length()>0)) {
            urlTail = "?" + s;
            if (urlTail.charAt(1)=='&') // change ?&arg1 into ?arg1
              urlTail=urlTail.replaceFirst("&","");

        }
        // TODO: should improve on this, now if the remotehost parameter already contains http:// the proxy fails
        //       besides, it should support more than just http (ftp, https,..)
        url="http://"+remotehost+( (remoteport!=null)&&(remoteport.length()>0)? ":"+remoteport:"")+urlTail;
        Hashtable headers = new Hashtable();
        getHeaders(httpservletrequest, headers);
        GetPost getpost = new GetPost();
        if(!getpost.doAction(httpservletrequest.getMethod().toUpperCase(), url, null, headers, -1, proxyHost, proxyPort, httpservletresponse))
            httpservletresponse.sendError(503);
    }

    public void doPost(HttpServletRequest httpservletrequest, HttpServletResponse httpservletresponse)
        throws ServletException, IOException
    {
        String s = httpservletrequest.getQueryString();
        String url = "";
        String urlTail = "";
        String remotehost =""; 
        String remoteport="";
        if ((s!=null) ||(s.length() >3)) {
          // we need to extract the target url from the parameters remotehost and remoteport
          remotehost = findString(s,REMOTE_HOST);
          s=s.replaceFirst(REMOTE_HOST+"="+remotehost,"");
          remoteport = findString(s,REMOTE_PORT);
          s=s.replaceFirst(REMOTE_PORT+"="+remoteport,"");
          if((s != null) && (s.length()>0)) {
            urlTail = "?" + s;
            if (urlTail.charAt(1)=='&') // change ?&arg1 into ?arg1
              urlTail=urlTail.replaceFirst("&","");
            }
        }
        Hashtable hashtable = new Hashtable();
        Hashtable params = new Hashtable();
        String param;
        for( Enumeration enumeration = httpservletrequest.getParameterNames(); 
             enumeration.hasMoreElements(); 
            ) {
             param = (String)enumeration.nextElement();
             if (REMOTE_HOST.equalsIgnoreCase(param)) { 
               remotehost=httpservletrequest.getParameter(param);
             } 
             else if (REMOTE_PORT.equalsIgnoreCase(param)) { 
               remoteport=httpservletrequest.getParameter(param);
             } 
             else {
               params.put(param, httpservletrequest.getParameter(param));
             }
            }
        getHeaders(httpservletrequest, hashtable);
        GetPost getpost = new GetPost();
        if(!getpost.doAction(httpservletrequest.getMethod().toUpperCase(), url, params, hashtable, -1, proxyHost, proxyPort, httpservletresponse))
            httpservletresponse.sendError(503);
    }

    private void getHeaders(HttpServletRequest httpservletrequest, Hashtable headers)
    {
        String s;
        for(Enumeration enumeration = httpservletrequest.getHeaderNames(); enumeration.hasMoreElements(); headers.put(s, httpservletrequest.getHeader(s)))
            s = (String)enumeration.nextElement();

    }

     private static String findString(String text, String findStr) {
        if ((text=="") ||(text==null)) return "";
        String host="";
        int hostPos = text.indexOf(findStr);
        if (hostPos>-1) {
        // either s contains: findStr=value<eos> or findStr=value&
        int endHostPost = text.indexOf('&',hostPos);
        if (endHostPost > -1) {
          host = text.substring(hostPos, endHostPost);
          if (hostPos > 0) {
            text = text.substring(0, hostPos-1)+text.substring(endHostPost+1);
          }
          else {
            text = text.substring(endHostPost+1);
          }
        }
        else  {
          host = text.substring(hostPos);
          if (hostPos > 0) {
            text = text.substring(0, hostPos-1)+text.substring(endHostPost+1);
          }
          else {
            text = "";
          }
        }       
        return host.substring(hostPos+findStr.length()+1);
        }
        else return "";
    }
    private String proxyHost;
    private String proxyPort;
}